function getTimestamp (timestamp) {
    const pad = (n,s=2) => (`${new Array(s).fill(0)}${n}`).slice(-s);
    const d = new Date(timestamp * 1000);

    return `${pad(d.getFullYear(),4)}-${pad(d.getMonth()+1)}-${pad(d.getDate())}`;
}
let selectedLeagueName = ''
let selectedMatchId = '';
let selectedLeagueId = '';
let generating = false;
jQuery(document).ready(function($) {
    $('.create-article-link').on('click', function() {
        $('.generate-wrapper').removeClass('d-none');
        $('.result-message-wrapper .alert-success').addClass('d-none');
        $('.result-message-wrapper .alert-danger').addClass('d-none');
        return false;
    });
    $('#create-article-wrapper').on('click', '.advanced-wrapper-toggle', function() {
        $('.advanced-wrapper').toggleClass('d-none');
        window.scrollTo(0, document.body.scrollHeight);
        return false;
    })
    $('#create-article-wrapper').on('click', '.generate-button', function() {
        if (generating) return;
        const title = $('input#title').val();
        const language = $('#language').find(":selected").val();
        const media = $('#includeMedia').prop("checked");
        const tone = $('#tone').val();
        const extraDirectionToDo = $('#extraDirectionToDo').val();
        const extraDirectionToAvoid = $('#extraDirectionToAvoid').val();
        const SEOKeyword = $('#SEOKeyword').val();
        $('.generate-button').addClass('disabled');
        $('.generate-button').attr('disabled', 'disabled');
        const data = {
            matchId: selectedMatchId,
            leagueId: selectedLeagueId,
            language: language  || "English",
            tone: tone || "Normal",
            title: title,
            extraPositivePrompt: extraDirectionToDo,
            extraNegativePrompt: extraDirectionToAvoid,
            includeMedia: !!media,
            SEOKeyword: SEOKeyword
        }
        generating = true;
        $.ajax({
            url: fwAjax.ajax_url,
            type: 'post',
            data: {
                action: 'fw_create_action',
                data: data,
                security: fwAjax.security
            },
            success: function(response) {
                // Handle the response
                generating = false;
                selectedMatchId = '';
                selectedLeagueId = '';
                selectedLeagueName = '';
                $('#generate-article').addClass('d-none');
                $('#matches').html('');
                $('.generate-button').removeClass('disabled');
                $('.generate-button').removeAttr('disabled');
                $('.generate-wrapper').addClass('d-none');
                $('.result-message-wrapper .alert-success').removeClass('d-none');
                $('.result-message-wrapper .alert-danger').addClass('d-none');
                $('.result-message-wrapper .payment').addClass('d-none');
                $('.view-article-link').attr('href', response.data.replaceAll('&amp;', '&'));
                window.scrollTo(0, 0);
                console.log(response, 'success');
            },
            error: function(response) {
                if(response.status === 402) {
                    generating = false;
                    $('.generate-button').removeClass('disabled');
                    $('.generate-button').removeAttr('disabled');
                    $('.result-message-wrapper .alert-success').addClass('d-none');
                    $('.result-message-wrapper .payment').removeClass('d-none');
                    window.scrollTo(0, 0);
                } else {
                    generating = false;
                    $('.generate-button').removeClass('disabled');
                    $('.generate-button').removeAttr('disabled');
                    $('.result-message-wrapper .alert-success').addClass('d-none');
                    $('.result-message-wrapper .alert-danger').removeClass('d-none');
                    $('.result-message-wrapper .payment').addClass('d-none');
                    window.scrollTo(0, 0);
                }
                console.log(response, 'error');
            }
        });
        return false;
    });

    $('#create-article-wrapper').on('click', '.match', function() {
        const matchId = $(this).attr('data-matchId');
        const title = $(this).attr('data-title');
        $('.match').not($(this)).removeClass('active');
        $(this).addClass('active');
        $('input#title').val(`${selectedLeagueName} - ${title}`)
        $('#generate-article').removeClass('d-none');
        window.scrollTo(0, document.body.scrollHeight);
        selectedMatchId = matchId;
    });
    $('#create-article-wrapper').on('click', '.league', function() {
        const leagueId = $(this).attr('data-leagueId');
        selectedLeagueName = $(this).attr('data-name');
        selectedLeagueId = leagueId;
        $('.league').not($(this)).removeClass('active');
        $(this).addClass('active');
        console.log('leagueId', leagueId);
        $('#matches').html("<h1 style='text-align: center;'><hr>Loading Matches...</h1>");
        $.ajax({
            url: fwAjax.ajax_url,
            type: 'post',
            data: {
                action: 'fw_action',
                data: {leagueId},
                security: fwAjax.security
            },
            success: function(response) {
                // Handle the response
                if(response && response.data){
                    let htmlMatches = '';
                    for (const responseElement of response.data) {
                        htmlMatches += '<div class="match-wrapper">';
                            htmlMatches += `<button class="match" data-matchId="${responseElement.id}" data-title="${responseElement.homeTeam} vs ${responseElement.awayTeam} (${responseElement.homeScore} : ${responseElement.awayScore})" type="button">`;
                                htmlMatches += `<div>`;
                                    htmlMatches += `<img src="https://statstriker.com/${responseElement.homePhoto}" alt="${responseElement.homeTeam}"/>`;
                                    htmlMatches += "<div class='match-score'>"
                                        htmlMatches += `<span> ${responseElement.homeTeam}</span>`;
                                        htmlMatches += `<span> (${responseElement.homeScore} : ${responseElement.awayScore}) </span>`;
                                        htmlMatches += `<span>${responseElement.awayTeam} </span>`;
                                    htmlMatches += "</div>"
                                    htmlMatches += `<img src="https://statstriker.com/${responseElement.awayPhoto}" alt="${responseElement.awayTeam}"/>`;
                                htmlMatches += `</div>`;
                                htmlMatches += `<div class="match-date">`;
                                    htmlMatches += `${getTimestamp(responseElement.timestamp)}`;
                                htmlMatches += `</div>`;
                            htmlMatches += '</button>';
                        htmlMatches += '</div>';
                    }
                    $('#matches').html(`
                        <hr>
                        <h2>2- Select Match</h2>
                        <div style="overflow-y: scroll; height: 250px; display: flex; flex-wrap: wrap; justify-content: center;">
                            ${htmlMatches}
                        </div>
                    `);
                    window.scrollTo(0, document.body.scrollHeight);
                }
                $('#my-div').html(response);
            }
        });
    });
});